﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.3
@EndOfDesignText@
Sub Class_Globals
	Private PanelBack, ParentPanel As Panel
	Public TopImg, MiddleImg As ImageView
	Private ParentModule As Object
	Private ParentEvent As String
	Private TagObject As Object
	Private TextData As String
	Private LayerList As List
	Private FileNameList As List
	Private ClickingEnabled=True As Boolean
	Private LayerTagMap As Map_B4X
	Private XUI As XUI
	Type LayerBorderAndColorProperties (Color As Int, Circular As Boolean, BorderSize As Int, BorderColor As Int, BorderRadiusByHeight as Boolean, Padding As Int)
End Sub

'redo this class to add unlimitted layers

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(CallingModule As Object, HoldingPanel As Panel, Event As String, BackgroundColor As Int)
	ParentModule=CallingModule
	ParentEvent=Event
	ParentPanel=HoldingPanel
	
	PanelBack.Initialize("")
	TopImg.Initialize("TopImg")
	MiddleImg.Initialize("")
	HoldingPanel.AddView(PanelBack,0,0,HoldingPanel.Width,HoldingPanel.Height)
	PanelBack.AddView(MiddleImg,0,0,HoldingPanel.Width,HoldingPanel.Height)
	PanelBack.AddView(TopImg,0,0,HoldingPanel.Width,HoldingPanel.Height)
	PanelBack.Color=BackgroundColor
	
	LayerList.Initialize
	FileNameList.Initialize
	LayerTagMap.Initialize
End Sub

Public Sub SetLayerImage(LayerNumber As Int, ImageBmp As Bitmap, KeepAspectRatio As Boolean)
	Dim imgvw=LayerList.Get(LayerNumber) As ImageView
	If KeepAspectRatio Then
#if b4a
		imgvw.SetBackgroundImage(ImageBmp).Gravity=Gravity.CENTER
#else if b4i
		imgvw.Bitmap=ImageBmp
		imgvw.ContentMode=imgvw.MODE_FIT
#end if		
	Else
#if b4a
		imgvw.SetBackgroundImage(ImageBmp).Gravity=Gravity.FILL
#else if b4i
		imgvw.Bitmap=ImageBmp
		imgvw.ContentMode=imgvw.MODE_FILL
#end if				
	End If
End Sub

Public Sub SetLayerImage2(LayerNumber As Int, ImageFileName As String, KeepAspectRatio As Boolean)
	Log("trying to set layer image - layer = "&LayerNumber)
	Log("imagefile = "&ImageFileName)
	Dim ImageBmp As Bitmap
	ImageBmp=LoadBitmapResize(File.DirAssets, ImageFileName, ParentPanel.Width, ParentPanel.Height, KeepAspectRatio)
	SetLayerImage(LayerNumber, ImageBmp, KeepAspectRatio)
End Sub

Public Sub SetLayerColor(LayerNumber As Int, Color As Int)
	Dim imgvw=LayerList.Get(LayerNumber) As B4XView
	imgvw.Color=Color
End Sub

Public Sub AddBmpLayer(ImageBmp As Bitmap, KeepAspectRatio As Boolean, OtherProperties As LayerBorderAndColorProperties, Tag As Object)
	Dim i As ImageView
	i.Initialize("LayeredImage")
	PanelBack.AddView(i,OtherProperties.Padding,OtherProperties.Padding, PanelBack.Width-OtherProperties.Padding*2, PanelBack.Height-OtherProperties.Padding*2)
	Try
		If OtherProperties.IsInitialized Then
			Dim LongestSide As Int = i.Height
			If i.Width>LongestSide Then LongestSide=i.Width
			Dim b4xv As B4XView = i
			Dim CornerRadius = 0 As Int
			If OtherProperties.circular Then
				CornerRadius = LongestSide/2
			End If
			b4xv.SetColorAndBorder(OtherProperties.Color, OtherProperties.BorderSize, OtherProperties.BorderColor, CornerRadius)		
		End If
	Catch
	End Try
	LayerList.Add(i)
	LayerTagMap.Put(Tag, i)
	i.Tag=Tag
	SetLayerImage(LayerList.Size-1, ImageBmp, KeepAspectRatio)
End Sub

Public Sub AddBmpLayer2(ImageFileName As String, KeepAspectRatio As Boolean, OtherProperties As LayerBorderAndColorProperties, tag As Object)
	Dim ImageBmp As B4XBitmap = XUI.LoadBitmap(File.DirAssets, ImageFileName)
	'XUI.LoadBitmapResize(File.DirAssets, ImageFileName, ParentPanel.Width, ParentPanel.Height, KeepAspectRatio)
	FileNameList.Add(ImageFileName)
	AddBmpLayer(ImageBmp,KeepAspectRatio, OtherProperties, tag)
End Sub

'adds an image layer that disappears after the specified timeout
Public Sub AddBmpLayerWithTimeout(ImageBmp As Bitmap, KeepAspectRatio As Boolean,TimeToShowMS As Int, OtherProperties As LayerBorderAndColorProperties, tag As Object)
	AddBmpLayer(ImageBmp, KeepAspectRatio, OtherProperties, tag)
	Sleep(TimeToShowMS)
	RemoveLayer(LayerList.Size-1)
End Sub

'adds an image layer from file that disappears after the specified timeout
Public Sub AddBmpLayerWithTimeout2(ImageFileName As String, KeepAspectRatio As Boolean, TimeToShowMS As Int, OtherProperties As LayerBorderAndColorProperties, tag As Object)
	AddBmpLayer2(ImageFileName, KeepAspectRatio, OtherProperties, tag)
	Sleep(TimeToShowMS)
	RemoveLayer(LayerList.Size-1)
End Sub

'this is under construction
Public Sub AddBmpRoundLayer(ImageBmp As Bitmap, KeepAspectRatio As Boolean)
#if b4a
	If Starter.API>11 Then
		Dim bd As BitmapDrawable
		bd.Initialize(ImageBmp)
		Dim circularImage As CircularDrawable
		circularImage.SetDrawable(bd)
	End If
#else if b4i

#end if
End Sub


'Set TextSize to 0 to automatically scale text
Public Sub AddTextLayer(Text As String,TextColor As Int, TextSize As Int, OtherProperties As LayerBorderAndColorProperties,  tag As Object)
	Dim l As Label
	l.Initialize("LayeredImage")
	PanelBack.AddView(l,OtherProperties.Padding,OtherProperties.padding,PanelBack.Width-OtherProperties.padding*2,PanelBack.Height-OtherProperties.padding*2)
	l.Color=OtherProperties.Color
	l.Text=Text
	l.TextColor=TextColor
	Dim lbx As B4XView = l
	If TextSize=0 Then
#if b4a
		LabelsExtra.AutosizeText(l, l.text)
#else b4i
		lbx.TextSize=l.Height
		l.AdjustFontSizeToFit=True
#End If
	Else		
		lbx.TextSize=TextSize
		l.AdjustFontSizeToFit=True
	End If
	lbx.SetTextAlignment("CENTER", "CENTER")
	Dim LongestSide As Int = l.Height
	If l.Width>LongestSide Then LongestSide=l.Width
	Dim b4xv As B4XView = l
	
	Dim CornerRadius = 0 As Int
	If OtherProperties.circular Then
		CornerRadius = LongestSide/2
	End If
	If OtherProperties.BorderRadiusByHeight Then
		CornerRadius = l.Height/2
	End If
	b4xv.SetColorAndBorder(OtherProperties.Color, OtherProperties.BorderSize, OtherProperties.BorderColor, CornerRadius)
	LayerList.Add(l)
	LayerTagMap.Put(tag, l)
	l.Tag=tag
End Sub

'Set TextSize to 0 to automatically scale text and removes after the specified amount of time
Public Sub AddTextLayerWithTimeout(Text As String,TextColor As Int, TextSize As Int, OtherProperties As LayerBorderAndColorProperties, TimeToShowMS As Int, tag As Object)
	AddTextLayer(Text, TextColor, TextSize, OtherProperties,  tag)
	Sleep(TimeToShowMS)
	RemoveLayer(LayerList.Size-1)
End Sub

Public Sub AddColorLayer(Color As Int, Circular As Boolean, BorderSize As Int, BorderColor As Int, tag As Object)
	Dim p As Panel
	p.Initialize("")
	p.Color=Color
	PanelBack.AddView(p,0,0,PanelBack.Width,PanelBack.Height)
	If Circular Then
		Dim LongestSide As Int = p.Height
		If p.Width>LongestSide Then LongestSide=p.Width
		Dim b4xv As B4XView = p
		b4xv.SetColorAndBorder(Color, BorderSize, BorderColor, LongestSide/2)
	End If
	LayerList.Add(p)
	LayerTagMap.Put(tag, p)
	p.Tag=tag
End Sub

Public Sub AddColorLayerWithTimeout(Color As Int, Circular As Boolean, BorderSize As Int, BorderColor As Int, TimeToShowMS As Int, tag As Object)
	AddColorLayer(Color, Circular, BorderSize, BorderColor, tag)
	Sleep(TimeToShowMS)
	RemoveLayer(LayerList.Size-1)
	LayerTagMap.Remove(tag)
End Sub

Public Sub GetLayerByTag(Tag As Object) As B4XView
	Return LayerTagMap.Get(Tag)
End Sub

Sub LayeredImage_click
	Log("in layeredimageview click")
	If Not(ClickingEnabled) Then Return
'	Log("trying to call main sub "&ParentEvent & "_click")
	If XUI.SubExists(ParentModule,ParentEvent & "_click", 1) Then 
		Log("trying to call main sub "&ParentEvent & "_click")
		CallSubDelayed2(ParentModule,ParentEvent & "_click",Me)
	End If
End Sub

Sub LayeredImage_longclick
	Log("in layeredimageview click")
	If Not(ClickingEnabled) Then Return
'	Log("trying to call main sub "&ParentEvent & "_longclick")
	If XUI.SubExists(ParentModule,ParentEvent & "_longclick", 1) Then 
		Log("trying to call main sub "&ParentEvent & "_longclick")
		CallSubDelayed2(ParentModule,ParentEvent & "_longclick",Me)
	End If
End Sub

Sub RemoveLayer(LayerNum As Int)
	Log("should try to remove")
	Try
		Dim b4xv As B4XView = LayerList.Get(LayerNum)
		b4xv.RemoveViewFromParent
		LayerList.RemoveAt(LayerNum)
	Catch
		Log(LastException.Message)
	End Try
End Sub

Sub setTag(TheTag As Object)
	TagObject=TheTag
End Sub

Sub getTag As Object
	Return TagObject
End Sub

Sub setDescription(Text As String)
	TextData=Text
End Sub

Sub getDescription As String
	Return TextData
End Sub

Sub setEnabled(ClickEnabled As Boolean)
	ClickingEnabled=ClickEnabled
End Sub

Sub getEnabled As Boolean
	Return ClickingEnabled
End Sub

Sub setBackgroundColor(color As Int)
	PanelBack.Color=color
End Sub